# define MOTOROLA 1
# define SEROM 1
# define ESSAI 1


/*********************************************************************/
/*                      Fichiers "include".                          */
/*********************************************************************/

#ifdef MICEL
# define VPUBLIC 1
#endif

# ifdef MACEL
# define VPUBLIC 1
# endif

# include "stdio.h"
# include "headerc.h"

# ifdef   ATARI
# include "osbind.h"
# include "vdibind.h"
# endif

# ifdef PC
# include "stdlib.h"
# include "fcntl.h"
# include "malloc.h"
# include "string.h"
# include "dos.h"
# endif

# ifdef   RT
# include <gslerrno.h>
# endif
/*********************************************************************/
/*                      Caracteristiques ecran.                      */
/*********************************************************************/

# define ECRAN  0xb8000000      /* Adresse de debut d'ecran. */
# define ECRAN2 0xba000000      /* Adresse de debut d'ecran. */

# define RESOLX(p)      reso[0][p]
# define RESOLY(p)      reso[1][p]

# define HTEXT	texatt[0]
# define LTEXT  texatt[1]

# define DECXSOURIS  (3*LTEXT)
# define DECYSOURIS  (HTEXT>>1)

# define DXMEN  menu.dx         /* Largeur du menu.          */
# define DYMEN  menu.dy         /* Hauteur du menu.          */

# define DXSAI  info.dx         /* Largeur de la zone saisie.*/
# define DYSAI  info.dy         /* Hauteur "  "   "      "  .*/

# define DXFEN  ((lnat)graph.dx)/* Largeur de la fenetre gra.*/
# define DYFEN  ((lnat)graph.dy)/* Hauteur  "  "    "     " .*/
# define VXMFEN (DXFEN-1)           /* Plus grande abscisse.     */
# define VYMFEN (DYFEN-1)          /*Plus grande ordonnee.     */
# define VXSCRO (VXMFEN-((lnat)menu.dx))        /* Debut de scroll horiz.    */
# define VYSCRO (VYMFEN-2)      /*   "    "   "    verti.    */
# define VSCROX (DXFEN/2)/* Valeur du scroll horiz.   */
# define VSCROY (DYFEN/2)/*   "    "    "    verti.   */

# define NB_LIGNE 22
# define NB_COL   60
# define NB_RESO  4
/*********************************************************************/
/*                           Menu.                                   */
/*********************************************************************/

# define TTITRE 16              /* Taille maximum d'un titre.*/
# define NB_MAX 20              /* Nombre maximum de choix.  */
# define NB_MENUS 10            /* Nombre max de menus.      */

/*********************************************************************/
/*                      Couleurs.                                    */
/*********************************************************************/

# define NOIR   0
# define BLANC  15
# define VERT   12
# define CYAN   4
# define ROUGE  9
# define MAGEN  5
# define BRUN   6
# define BLEU   7
# define GRIS   8
# define CROUGE 3
# define CBLEU  10
# define FCYAN  11
# define CVERT  2
# define ORANGE 13
# define JAUNE  14
# define ROSE   1
# define NON_COULEUR 16

# define LCON  2
# define LDCO  1

# define COUL_MAX      15
# define LEVE        0xff
# define LAVE        0xfe

# define LARG_CADRE    18
# define HAUT_CADRE    30

# define MAXNIV 17

# define OVER 1
# define NF   2
# define BAD  3
# define STP  4
# define NFILS 5

# define ESC 27
/*********************************************************************/
/*                      Divers.                                      */
/*********************************************************************/

# define ON     1
# define OFF    0
# define VRAI   1
# define FAUX   0
# define UP     1
# define DO     2
# define LE     3
# define RI     4
# define SXY    3
# define SX     1
# define SY     2
# define SB     7
# define SDEP   8
# define SYMB   1
# define LOGI   2
# define FOND   4
# define ELOGI  8
/* pour le symbolique */
#define HORIZONTAL	1
#define VERTICAL	0
/* pour inspect : type des objets */
#define IMASK	1
#define ICONN	2
#define IBLOC	4
#define IAB__	8
#define IMOTI	16
#define IINSP	32
# define LPILE TMAX

# ifdef PC
# ifndef DEMO
# define TMAX   1200
# define T2MAX  1748
# endif
# ifdef DEMO
# define TMAX 512
# define T2MAX 1748
# endif
# endif


# ifdef RT
# define TMAX   18192
# define T2MAX  3072
# endif

# ifdef ATARI
# define TMAX   6000
# define T2MAX  2048
# endif

# ifdef SUN
# define TMAX   80000
# define T2MAX  3072
# endif

# ifdef NCR
# define TMAX   40000
# define T2MAX  3072
# endif

# ifdef UVAX
# define TMAX   80000
# define T2MAX  4096
# endif

# ifdef SM9
# define TMAX   18192
# define T2MAX  3072
# endif

# define TAILLE_MES 150
#define  TAILLE_CHAINE 64
# define COUVE  (2000l<<graph.res)
# define CONNECT 0x20
# define ONLINE 0x10

/*********************************************************************/
/*                      Affichage.                                   */
/*********************************************************************/

# define CADRE  0
# define TITRE  1
# define OPTION 2
# define CHOIX  3
# define AIDE   4
# define INFO   5
# define SAISIE 6

/*********************************************************************/
/*                      Fonctions.                                   */
/*********************************************************************/

# define sup(a,b)  ((a>b) ? a : b)
# define inf(a,b)  ((a<b) ? a : b)
# define abs(x)    ((x<0) ?-(x):x)

/*********************************************************************/
/*              Primitives d'acces aux champs de 'setup'             */
/*********************************************************************/

# define acc_mode       setup->mode
# define acc_eseq	acc_conf.rlog

# define acc_nbniv      setup->niveau.nb
# define acc_nniv(i)    setup->niveau.nom[i]
# define acc_cniv(i)    setup->niveau.couleur[i]
# define acc_super(i,j) setup->niveau.super[i][j]
# define acc_style(i)	acc_super(i,0)
# define acc_profo(i)	acc_super(i,1)
# define acc_maxniv     setup->niveau.maxniv
# define acc_cont(i)    setup->niveau.contact[i]
# define tst_cont(i,j)  (setup->niveau.contact[i]) & (1<<j)
# define set_cont(i,j)  (setup->niveau.contact[i]) |= (1<<j)
# define res_cont(i,j)  (setup->niveau.contact[i]) &= (~(1<<j))

# define acc_entdir     setup->declar.entdir
# define acc_sordir     setup->declar.sordir
# define acc_nbservi    setup->declar.nbservi
# define acc_servi(i)   setup->declar.servi[i]
# define acc_nbalim     setup->declar.nbalim
# define acc_alim(i)    setup->declar.alim[i]

# define acc_souris     setup->periph.souris
# define acc_traceur    setup->periph.traceur

# define acc_routeur    setup->outils.routeur
# define acc_compil     setup->outils.compil
# define acc_testeur    setup->outils.testeur
# define acc_simul      setup->outils.simulateur

# define acc_capafic    setup->capa_nom
# define acc_fondfic    setup->fond_nom

# define acc_lam	acc_conf.lam

# define acc_wmin(i)	setup->wmin[i]
# define acc_ext(i)		setup->ext[i]
# define acc_version	setup->version

# define acc_sufflog		setup->syntaxe.sufflog
# define acc_suffphy		setup->syntaxe.suffphy
# define acc_titre      setup->syntaxe.titre
# define acc_preflat	setup->syntaxe.prefixe_flatten
# define acc_ncatal	setup->syntaxe.nom_du_catal
# define acc_nbcatal	setup->syntaxe.taille_du_catal
# define acc_path       setup->path
# define acc_pathfile   setup->pathfile
# define acc_pathcatal  setup->pathcatal

# define acc_up		setup->up
# define acc_down	setup->down
# define acc_right	setup->right
# define acc_left	setup->left
# define acc_rep	setup->rep
# define acc_c1		setup->c1
# define acc_c2		setup->c2
# define acc_c3		setup->c3

# define acc_moti	setup->moti

# define acc_nbmotif			setup->motifs.nbmotif
# define acc_motiflayer(i,j)		setup->motifs.tab_layer[i][j]
# define acc_nmotif(i)			setup->motifs.tab_motif[i].name
# define acc_nbsegmotif(i)		setup->motifs.tab_motif[i].nbseg
# define acc_xsegmotif(i,j)		setup->motifs.tab_motif[i].tab_seg[j].x
# define acc_ysegmotif(i,j)		setup->motifs.tab_motif[i].tab_seg[j].y
# define acc_dxsegmotif(i,j)		setup->motifs.tab_motif[i].tab_seg[j].dx
# define acc_dysegmotif(i,j)		setup->motifs.tab_motif[i].tab_seg[j].dy
# define acc_layersegmotif(i,j)	setup->motifs.tab_motif[i].tab_seg[j].layer
# define acc_xbbmotif(i)		setup->motifs.tab_motif[i].xbb
# define acc_ybbmotif(i)		setup->motifs.tab_motif[i].ybb
# define acc_dxbbmotif(i)		setup->motifs.tab_motif[i].dxbb
# define acc_dybbmotif(i)		setup->motifs.tab_motif[i].dybb
# define acc_xabmotif(i)		setup->motifs.tab_motif[i].xab
# define acc_yabmotif(i)		setup->motifs.tab_motif[i].yab
# define acc_dxabmotif(i)		setup->motifs.tab_motif[i].dxab
# define acc_dyabmotif(i)		setup->motifs.tab_motif[i].dyab

# define acc_conf       setup->defconf
# define acc_part       acc_conf.pat

/*********************************************************************/
# define acc_eloise     "\\eloise\\"
/*********************************************************************/
/*                       BENSON                                      */
/*********************************************************************/
 /* Bits de mode */

# define UNIF   1
# define TRES   2

        /* Bits de la cle */

# define COPI   1
# define CART   2
# define CADR   4

/*              PORTABILITE........                                */


/*******************************************************************/
/*                       FICHIERS                                  */
/*******************************************************************/

# ifdef ATARI
# define LBI     "rb"
# define EBI     "wb"
# define LTE     "r"
# define ETE     "w"
# define ALLOC(p)   Malloc(p)
# endif

# ifdef  PC
# define LBI    "rb"
# define EBI    "wb"
# define LTE    "rt"
# define ETE    "wt"
# define ALLOC(p)  malloc(p)
# endif

# ifdef RT 
# define LBI    "r"
# define EBI    "w"
# define LTE    "r"
# define ETE    "w"
# define ALLOC(p)  malloc(p)
# endif

# ifdef SUN
# define LBI    "r"
# define EBI    "w"
# define LTE    "r"
# define ETE    "w"
# define ALLOC(p)  malloc(p)
# endif

# ifdef NCR
# define LBI    "r"
# define EBI    "w"
# define LTE    "r"
# define ETE    "w"
# define ALLOC(p)  malloc(p)
# endif

# ifdef UVAX
# define LBI    "r"
# define EBI    "w"
# define LTE    "r"
# define ETE    "w"
# define ALLOC(p)  malloc(p)
# endif

# ifdef SM9
# define LBI    "r"
# define EBI    "w"
# define LTE    "r"
# define ETE    "w"
# define ALLOC(p)  malloc(p)
# endif

# ifdef SEROM
# ifdef RT
# define VLISA  " AIX-UNIX  PC-RT  Version ALLIANCE 2.14  UPMC Dec 1992"
# endif

# ifdef ATARI
# define VLISA  " GEM  ATARI ST    Version ALLIANCE 2.14  UPMC Dec 1992"
# endif

# ifdef PC
# define VLISA   "MS-DOS PC-AT     Version ALLIANCE 2.14  UPMC Dec 1992"
# endif

# ifdef  SUN
# define VLISA   "UNIX X-Window v11r4  Version ALLIANCE 2.14 UPMC Dec 1992"
# endif

# ifdef  NCR
# define VLISA   "UNIX System V  NCR 32/400  Version ALLIANCE 2.14 UPMC Dec 1992"
# endif

# ifdef UVAX
# define VLISA   "ULTRIX  Micro-VAX   Version ALLIANCE 2.14 UPMC Dec 1992"
# endif
# define MAINT "sol11"
# endif
